﻿//########################
//InDesignCS4  
//oimoh - はいさい！（InDesign JavaScript CS3） 
//http://d.hatena.ne.jp/oimoh/
//を参考にさせていただきました。
//たけうちとおる
//########################

//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();
function main(){
	//ダイアログを作成する
	myDialog = app.dialogs.add({name:"オブジェクトのサイズ変更"});
	with(myDialog){
		with(dialogColumns.add()){
			staticTexts.add({staticLabel:"選択されたオブジェクトをすべて拡大縮小します。"});
			with(borderPanels.add()){
				with (dialogColumns.add()){
					staticTexts.add({staticLabel:"X方向の基準"});
					var myXSelect = radiobuttonGroups.add();
					with(myXSelect){
						radiobuttonControls.add({staticLabel:"左"});
						radiobuttonControls.add({staticLabel:"中", checkedState:true});
						radiobuttonControls.add({staticLabel:"右"});
					}
				}
				with (dialogColumns.add()){
					staticTexts.add({staticLabel:"Y方向の基準"});
					var myYSelect = radiobuttonGroups.add();
					with(myYSelect){
						radiobuttonControls.add({staticLabel:"上"});
						radiobuttonControls.add({staticLabel:"中", checkedState:true});
						radiobuttonControls.add({staticLabel:"下"});
					}
				}
				with (dialogColumns.add()){
					var Listpercent = new Array("100", "90", "80", "70", "60", "50", "40", "30", "20", "10", "0");
					staticTexts.add({staticLabel:"Wの変倍率"});
					var myPerW = percentComboboxes.add({editValue:100,minimumValue:0,maximumValue:1000,stringList:Listpercent});
					staticTexts.add({staticLabel:"Hの変倍率"});
					var myPerH = percentComboboxes.add({editValue:100,minimumValue:0,maximumValue:1000,stringList:Listpercent});
				}
			}
			staticTexts.add({staticLabel:"(C)2009 Toru Takeuchi このスクリプトはフリーウェアです。"});
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		var myXSelectType = myXSelect.selectedButton;
		var myYSelectType = myYSelect.selectedButton;
		var myPerWvalue = myPerW.editValue*0.01;
		var myPerHvalue = myPerH.editValue*0.01;
		myDialog.destroy();
		indd_get_selected_box(myXSelectType,myYSelectType,myPerWvalue,myPerHvalue);
	}
	else{
		myDialog.destroy();
	}
}

//選択されたオブジェクトを調べる
function indd_get_selected_box(myXSelectType,myYSelectType,myPerWvalue,myPerHvalue){
	if (app.documents.length != 0){
		if (app.selection.length > 0){
			for(s = 0; s<app.selection.length; s++){
				myPageItem = app.selection[s];
				indd_resize_obj(myPageItem,myXSelectType,myYSelectType,myPerWvalue,myPerHvalue);
			}
		}else{
			alert("配置画像を選択して下さい");
		}
	}else{
		alert("ドキュメントを開いてください");
	}
}

//サイズを変更する
function indd_resize_obj(myPageItem,myXSelectType,myYSelectType,myPerWvalue,myPerHvalue){
	//try{
		if(myXSelectType == 0 && myYSelectType == 0){//左上
			var myAncorPoint = AnchorPoint.TOP_LEFT_ANCHOR;
		}else if(myXSelectType == 0 && myYSelectType == 1){//左中
			var myAncorPoint = AnchorPoint.LEFT_CENTER_ANCHOR;
		}else if(myXSelectType == 0 && myYSelectType == 2){//左下
			var myAncorPoint = AnchorPoint.BOTTOM_LEFT_ANCHOR;
		}else if(myXSelectType == 1 && myYSelectType == 0){//中上
			var myAncorPoint = AnchorPoint.TOP_CENTER_ANCHOR;
		}else if(myXSelectType == 1 && myYSelectType == 1){//中中
			var myAncorPoint = AnchorPoint.centerAnchor;
		}else if(myXSelectType == 1 && myYSelectType == 2){//中下
			var myAncorPoint = AnchorPoint.BOTTOM_CENTER_ANCHOR;
		}else if(myXSelectType == 2 && myYSelectType == 0){//右上
			var myAncorPoint = AnchorPoint.TOP_RIGHT_ANCHOR;
		}else if(myXSelectType == 2 && myYSelectType == 1){//右中
			var myAncorPoint = AnchorPoint.RIGHT_CENTER_ANCHOR;
		}else if(myXSelectType == 2 && myYSelectType == 2){//右下
			var myAncorPoint = AnchorPoint.BOTTOM_RIGHT_ANCHOR;
		}
		var myScaleMatrix = app.transformationMatrices.add({horizontalScaleFactor:myPerWvalue, verticalScaleFactor:myPerHvalue});
		myPageItem.transform(CoordinateSpaces.pasteboardCoordinates, myAncorPoint, myScaleMatrix);
		/*
[CoordinateSpaces]
CoordinateSpaces.INNER_COORDINATES
CoordinateSpaces.PARENT_COORDINATES
CoordinateSpaces.PASTEBOARD_COORDINATES

[AnchorPoint]
AnchorPoint.BOTTOM_CENTER_ANCHOR
AnchorPoint.BOTTOM_LEFT_ANCHOR
AnchorPoint.BOTTOM_RIGHT_ANCHOR
AnchorPoint.CENTER_ANCHOR
AnchorPoint.LEFT_CENTER_ANCHOR
AnchorPoint.RIGHT_CENTER_ANCHOR
AnchorPoint.TOP_CENTER_ANCHOR
AnchorPoint.TOP_LEFT_ANCHOR
AnchorPoint.TOP_RIGHT_ANCHOR
*/
		/*
		var myb = myPageItem.allGraphics[0].geometricBounds;
		var Y1 = myb[0];
		var X1 = myb[1];
		var Y2 = myb[2];
		var X2 = myb[3];
		var W = X2 - X1;
		var H = Y2 - Y1;
		var henW = (W * myPerWvalue);
		var henH = (H * myPerHvalue);
		var saW = (W - henW)*(myXSelectType/2);
		var saH = (H - henH)*(myYSelectType/2);
		var henY1 = Y1+(saH);
		var henX1 = X1+(saW);
		var henY2 = henY1+henH;
		var henX2 = henX1+ henW;
		myPageItem.allGraphics[0].geometricBounds = Array(henY1,henX1,henY2,henX2);
		*/
	//}catch(msg){
		//画像が配置されていない
	//}
}
